// Fire.h: Schnittstelle fr die Klasse Fire
//
//////////////////////////////////////////////////////////////////////



#ifndef FIRE_H
#define FIRE_H

#include <windows.h>
#pragma warning (disable : 4786)

#include <iostream.h>

//#define GLH_EXT_SINGLE_FILE
//#define GLH_NVEB_USING_CGGL

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <GL/glext.h>
#include <GL/wglext.h>
#include <Cg/cg.h>
#include <Cg/cgGL.h>
#include <corona.h>

#include <GLH/glh_obs.h>

#include "Arrays.h"

//using namespace std;
using namespace corona;

#define B	256
#define	frand()	((float)rand() / RAND_MAX)




class Fire
{
public:

	// constructors/destructors
	Fire();
	~Fire();

	// fields

	bool bbox_enabled;
	bool outlines_enabled; 
	bool fire_enabled;
	bool animation;

	int frames;

	// number of volumetric slices
	int slices_count;
	// time
	float time; 
	// speed
	float speed;
	// turbulance scale
	float turb_scale;

	GLuint fireHandle;
	GLuint permutationHandle;
	GLuint gradientHandle;
	GLuint fireQuads;

	

	// VS parameters
	CGparameter ModelView;
	CGparameter InverseModelView;
	CGparameter Proj;
	CGparameter Time;
	CGparameter PBind;
	CGparameter GBind;
	CGparameter FireTexBind;


	// PS parameter
	CGparameter Turb_Scale;

	// CG handles
	CGcontext cgContext;
	CGprofile cgVertexProfile;
	CGprofile cgFragmentProfile;
	CGprogram cgVertexProgram;
	CGprogram cgFragmentProgram;

	// methods
	void clear();
	bool init();
	void create_quads_list();
	void create_textures();
	void draw_outlines();
	void draw_fire(float update_time);

};

#endif