// Vector4.h: Schnittstelle fr die Klasse Vector4
//
//////////////////////////////////////////////////////////////////////

#include <malloc.h>

#include "Camera.h"
#include "TGALoader.h"
#include "Matrix4.h"
#include "Vector4.h"



class Wall {

	enum {CONST_X, CONST_Y, CONST_Z};

protected:
	
	int width;
	int height;
	float spacing;
	int numVerticesX;
	int numVerticesY;
	TGALoader texture;
	Vector4* vertices;
	Matrix4x4* objectToTangentSpaceMatrices;


public:

	// constructors
	Wall(int _width, int _height, float _spacing);
	
protected:


	void initGrid();

public:

	// methods
	float getWidth();
	float getHeight();
	float getNumVerticesX();
	float getNumVerticesY();
	float getSpacing();
	void LoadDetail(char* textureName);
	void LoadBumpmap(char* bumpmapName);
	unsigned int getDetailHandle();
	unsigned int getBumpHandle();
	Vector4* getVertices();

	void draw();
	void drawBump();

};