#include "Vector4.h"
#include "Arrays.h"
#include "TGALoader.h"
#include "Cg_Shader.h"

#include <GL/glut.h>
#include <cstdlib>
#include <malloc.h>
#include <corona.h>

using namespace corona;


class Water {

protected:
	const int nX,nY; // the grid size
	const float dx;  // horizontal distance between two grid neigbours
	
	Vector4 *verts;
	unsigned int waterHandle;

public:

	// constructors
	Water();
	Water(int _nX, int _nY, float _dx);
	Water(const Water &w);

protected:
	void initGrid(int nX, int nY);

public:
	// accessors
	float getSizeX();
	float getSizeY();
	float getDx();
	unsigned int getHandle();
	Vector4 *getVerts();

	// general functions
	draw();
	loadTexture();

};